﻿using ProjectGasolineTanker.Drawings;
namespace ProjectGasolineTanker.CollectionGenericObjects;

/// <summary>
/// Реализация абстрактной компании - каршеринг
/// </summary>
public class TruckSharingService : AbstractCompany
{
    /// <summary>
    /// Конструктор
    /// </summary>
    /// <param name="picWidth">Ширина</param>
    /// <param name="picHeight">Высота</param>
    /// <param name="collection">Коллекция</param>
    public TruckSharingService(int picWidth, int picHeight, ICollectionGenericObjects<DrawingTruck> collection) : base(picWidth, picHeight, collection)
    {
    }

    protected override void DrawBackgound(Graphics g)
    {

        int count_width = _pictureWidth / _placeSizeWidth; // кол-во мест в ширину
        int count_height = _pictureHeight / _placeSizeHeight;
        Pen pen = new(Color.Black, 3);
        for (int i = 0; i < count_width; i++)
        {
            for (int j = 0; j < count_height + 1; ++j)
            {
                g.DrawLine(pen, i * _placeSizeWidth + 10, j * _placeSizeHeight, i * _placeSizeWidth + _placeSizeWidth - 50, j * _placeSizeHeight); // вертикаль
                g.DrawLine(pen, i * _placeSizeWidth + 10, j * _placeSizeHeight, i * _placeSizeWidth + 10, j * _placeSizeHeight + _placeSizeHeight);
            }
        }
    }

    protected override void SetObjectsPosition()
    {

        int width = _pictureWidth / _placeSizeWidth;
        int height = _pictureHeight / _placeSizeHeight;
        int positionWidth = 0;
        int positionHeight = height - 1;

        if (_collection?.Count != null)
        {
            for (int i = 0; i < (_collection.Count); i++)
            {
                if (_collection.Get(i) != null)
                {
                    _collection.Get(i).SetPictureSize(_pictureWidth, _pictureHeight);
                    _collection.Get(i).SetPosition(_placeSizeWidth * positionWidth + 25, positionHeight * _placeSizeHeight + 10);
                }

                if (positionWidth < width - 1)
                {
                    positionWidth++;
                }

                else
                {
                    positionWidth = 0;
                    positionHeight--;
                }
                if (positionHeight < 0)
                {
                    return;
                }
            }
        }

    }
}
