﻿namespace ProjectGasolineTanker.Entities;
/// <summary>
/// Класс-сущность "Бензовоз"
/// </summary>
public class EntityGasolineTanker : EntityTruck
{
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }

    public void SetAdditionalColor(Color color)
    {
        AdditionalColor = color;
    }
    /// <summary>
    /// Признак (опция) наличия бака под бензин
    /// </summary>
    public bool GasTank { get; private set; }
    /// <summary>
    /// Признак (опция) наличия сигнального маяка на кабине
    /// </summary>
    public bool SignalBeacon { get; private set; }
    /// <summary>
    /// Шаг перемещения бензовоза
    /// </summary>
    public double Step => Speed * 200 / Weight;
    
    public EntityGasolineTanker(int speed, double weight, Color bodyColor, Color additionalColor, bool gasTank, bool signalBeacon) : base(speed, weight, bodyColor)

    {
        AdditionalColor = additionalColor;
        GasTank = gasTank;
        SignalBeacon = signalBeacon;
     }

}
